# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from thormang3_wholebody_module_msgs/WheelPose.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg
import sensor_msgs.msg

class WheelPose(genpy.Message):
  _md5sum = "e6ea3f8977c5efde3ebe6e3294c332dc"
  _type = "thormang3_wholebody_module_msgs/WheelPose"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string                  name
float64                 mov_time
float64                 via_time
sensor_msgs/JointState  via_joint_state
sensor_msgs/JointState  goal_joint_state
geometry_msgs/Pose      via_pevlis_pose
geometry_msgs/Pose      goal_pevlis_pose


================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['name','mov_time','via_time','via_joint_state','goal_joint_state','via_pevlis_pose','goal_pevlis_pose']
  _slot_types = ['string','float64','float64','sensor_msgs/JointState','sensor_msgs/JointState','geometry_msgs/Pose','geometry_msgs/Pose']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       name,mov_time,via_time,via_joint_state,goal_joint_state,via_pevlis_pose,goal_pevlis_pose

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(WheelPose, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.mov_time is None:
        self.mov_time = 0.
      if self.via_time is None:
        self.via_time = 0.
      if self.via_joint_state is None:
        self.via_joint_state = sensor_msgs.msg.JointState()
      if self.goal_joint_state is None:
        self.goal_joint_state = sensor_msgs.msg.JointState()
      if self.via_pevlis_pose is None:
        self.via_pevlis_pose = geometry_msgs.msg.Pose()
      if self.goal_pevlis_pose is None:
        self.goal_pevlis_pose = geometry_msgs.msg.Pose()
    else:
      self.name = ''
      self.mov_time = 0.
      self.via_time = 0.
      self.via_joint_state = sensor_msgs.msg.JointState()
      self.goal_joint_state = sensor_msgs.msg.JointState()
      self.via_pevlis_pose = geometry_msgs.msg.Pose()
      self.goal_pevlis_pose = geometry_msgs.msg.Pose()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2d3I().pack(_x.mov_time, _x.via_time, _x.via_joint_state.header.seq, _x.via_joint_state.header.stamp.secs, _x.via_joint_state.header.stamp.nsecs))
      _x = self.via_joint_state.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.via_joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.via_joint_state.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.via_joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.via_joint_state.position))
      length = len(self.via_joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.via_joint_state.velocity))
      length = len(self.via_joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.via_joint_state.effort))
      _x = self
      buff.write(_get_struct_3I().pack(_x.goal_joint_state.header.seq, _x.goal_joint_state.header.stamp.secs, _x.goal_joint_state.header.stamp.nsecs))
      _x = self.goal_joint_state.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.goal_joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.goal_joint_state.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.goal_joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.goal_joint_state.position))
      length = len(self.goal_joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.goal_joint_state.velocity))
      length = len(self.goal_joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.goal_joint_state.effort))
      _x = self
      buff.write(_get_struct_14d().pack(_x.via_pevlis_pose.position.x, _x.via_pevlis_pose.position.y, _x.via_pevlis_pose.position.z, _x.via_pevlis_pose.orientation.x, _x.via_pevlis_pose.orientation.y, _x.via_pevlis_pose.orientation.z, _x.via_pevlis_pose.orientation.w, _x.goal_pevlis_pose.position.x, _x.goal_pevlis_pose.position.y, _x.goal_pevlis_pose.position.z, _x.goal_pevlis_pose.orientation.x, _x.goal_pevlis_pose.orientation.y, _x.goal_pevlis_pose.orientation.z, _x.goal_pevlis_pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.via_joint_state is None:
        self.via_joint_state = sensor_msgs.msg.JointState()
      if self.goal_joint_state is None:
        self.goal_joint_state = sensor_msgs.msg.JointState()
      if self.via_pevlis_pose is None:
        self.via_pevlis_pose = geometry_msgs.msg.Pose()
      if self.goal_pevlis_pose is None:
        self.goal_pevlis_pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.mov_time, _x.via_time, _x.via_joint_state.header.seq, _x.via_joint_state.header.stamp.secs, _x.via_joint_state.header.stamp.nsecs,) = _get_struct_2d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.via_joint_state.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.via_joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.via_joint_state.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.via_joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.via_joint_state.position = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.via_joint_state.velocity = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.via_joint_state.effort = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 12
      (_x.goal_joint_state.header.seq, _x.goal_joint_state.header.stamp.secs, _x.goal_joint_state.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal_joint_state.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.goal_joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.goal_joint_state.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.goal_joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.goal_joint_state.position = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.goal_joint_state.velocity = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.goal_joint_state.effort = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 112
      (_x.via_pevlis_pose.position.x, _x.via_pevlis_pose.position.y, _x.via_pevlis_pose.position.z, _x.via_pevlis_pose.orientation.x, _x.via_pevlis_pose.orientation.y, _x.via_pevlis_pose.orientation.z, _x.via_pevlis_pose.orientation.w, _x.goal_pevlis_pose.position.x, _x.goal_pevlis_pose.position.y, _x.goal_pevlis_pose.position.z, _x.goal_pevlis_pose.orientation.x, _x.goal_pevlis_pose.orientation.y, _x.goal_pevlis_pose.orientation.z, _x.goal_pevlis_pose.orientation.w,) = _get_struct_14d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2d3I().pack(_x.mov_time, _x.via_time, _x.via_joint_state.header.seq, _x.via_joint_state.header.stamp.secs, _x.via_joint_state.header.stamp.nsecs))
      _x = self.via_joint_state.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.via_joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.via_joint_state.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.via_joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.via_joint_state.position.tostring())
      length = len(self.via_joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.via_joint_state.velocity.tostring())
      length = len(self.via_joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.via_joint_state.effort.tostring())
      _x = self
      buff.write(_get_struct_3I().pack(_x.goal_joint_state.header.seq, _x.goal_joint_state.header.stamp.secs, _x.goal_joint_state.header.stamp.nsecs))
      _x = self.goal_joint_state.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.goal_joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.goal_joint_state.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.goal_joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.goal_joint_state.position.tostring())
      length = len(self.goal_joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.goal_joint_state.velocity.tostring())
      length = len(self.goal_joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.goal_joint_state.effort.tostring())
      _x = self
      buff.write(_get_struct_14d().pack(_x.via_pevlis_pose.position.x, _x.via_pevlis_pose.position.y, _x.via_pevlis_pose.position.z, _x.via_pevlis_pose.orientation.x, _x.via_pevlis_pose.orientation.y, _x.via_pevlis_pose.orientation.z, _x.via_pevlis_pose.orientation.w, _x.goal_pevlis_pose.position.x, _x.goal_pevlis_pose.position.y, _x.goal_pevlis_pose.position.z, _x.goal_pevlis_pose.orientation.x, _x.goal_pevlis_pose.orientation.y, _x.goal_pevlis_pose.orientation.z, _x.goal_pevlis_pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.via_joint_state is None:
        self.via_joint_state = sensor_msgs.msg.JointState()
      if self.goal_joint_state is None:
        self.goal_joint_state = sensor_msgs.msg.JointState()
      if self.via_pevlis_pose is None:
        self.via_pevlis_pose = geometry_msgs.msg.Pose()
      if self.goal_pevlis_pose is None:
        self.goal_pevlis_pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.mov_time, _x.via_time, _x.via_joint_state.header.seq, _x.via_joint_state.header.stamp.secs, _x.via_joint_state.header.stamp.nsecs,) = _get_struct_2d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.via_joint_state.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.via_joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.via_joint_state.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.via_joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.via_joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.via_joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.via_joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 12
      (_x.goal_joint_state.header.seq, _x.goal_joint_state.header.stamp.secs, _x.goal_joint_state.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal_joint_state.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.goal_joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.goal_joint_state.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.goal_joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.goal_joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.goal_joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.goal_joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 112
      (_x.via_pevlis_pose.position.x, _x.via_pevlis_pose.position.y, _x.via_pevlis_pose.position.z, _x.via_pevlis_pose.orientation.x, _x.via_pevlis_pose.orientation.y, _x.via_pevlis_pose.orientation.z, _x.via_pevlis_pose.orientation.w, _x.goal_pevlis_pose.position.x, _x.goal_pevlis_pose.position.y, _x.goal_pevlis_pose.position.z, _x.goal_pevlis_pose.orientation.x, _x.goal_pevlis_pose.orientation.y, _x.goal_pevlis_pose.orientation.z, _x.goal_pevlis_pose.orientation.w,) = _get_struct_14d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2d3I = None
def _get_struct_2d3I():
    global _struct_2d3I
    if _struct_2d3I is None:
        _struct_2d3I = struct.Struct("<2d3I")
    return _struct_2d3I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_14d = None
def _get_struct_14d():
    global _struct_14d
    if _struct_14d is None:
        _struct_14d = struct.Struct("<14d")
    return _struct_14d
